import Item
import Field

class Category:
	
	def __init__(self, name, icon=0):
		self.name = name
		self.icon = icon
		self.item_list = []
		self.defaults = []
		
		# this is only as demo!!!
		#self.field_add("Text")
		#self.field_add("Location")
		#self.field_add("Owner", "combobox", "kup1, kup2, kup3")
		
	# add field to category settings
	
	def is_empty(self):
		if len(self.item_list) == 0:
			return True
		return False
	
	def field_add(self, name, field_type="text", default_value=""):
		if not self.field_present(name):
			if field_type == "combobox":
				values = default_value.split(', ')
				if len(values) == 0:
					value = []
					#self.defaults.append(Field.Field(name, field_type, ['']))
				else:
					value = values
					#self.defaults.append(Field.Field(name, field_type, values))
					
			else:
				value = default_value

			self.defaults.append(Field.Field(name, field_type, value))
			#self.field_select(name).set_valid_values(values)
			
	
	# add field to all items in category
	def field_add_recursive(self, name, field_type="text", default_value=""):
		for item in self.item_list:
			item.field_add(name, field_type, default_value)
			
	
	# delete field from category settings
	def field_delete(self, name):
		if self.field_present(name):
			for field in self.defaults:
				if field.get_name() == name:
					self.defaults.remove(field)
									 
	
	# delete field from all items in this category
	def field_delete_recursive(self, name):
		for item in self.item_list:
			item.field_delete(name)
			
	
	# delete a given value from a given field from defaults
	def value_delete_from_defaults(self, field_name, value):
		for default in self.defaults:
			if default.get_name() == field_name:
				if default.get_value() == value:
					default.set_value("")
	
	
	# delete a given value from a given field from all items in this category
	def value_delete_recursive(self, field_name, value):
		for item in self.item_list:
			if item.field_present(field_name):
				if item.field_select(field_name).get_value() == value:
					for default in self.defaults:
						if default.get_name() == field_name:
							if not default.get_value() == value:
								new_value = default.get_value()
							else:
								new_value = ""
					item.field_select(field_name).set_value(new_value)
									
					
	# returns True if a field exists in category settings
	def field_present(self, name):
		for field in self.defaults:
			if field.get_name() == name:
				return True
		return False
		
	def field_select(self, name):
		for field in self.defaults:
			if field.get_name() == name:
				return field
		return False
		
	# add an item to category
	def item_add(self, name):
		if not self.item_present(name):
			item = Item.Item(name, self.defaults)
			self.item_list.append(item)
			
	def item_move_here(self, item):
		if not self.item_present(item.get_name()):
			self.item_list.append(item)
			return True
		return False
	
	
	# delete item from category
	def item_delete(self, name):
		if self.item_present(name):
			self.item_list.remove(self.item_select(name))
	
	
	# return True if item with given name is in this category
	def item_present(self, name):
		for item in self.item_list:
			if item.get_name() == name:
				return True
		return False

	
	# return item with given name
	def item_select(self, name):
		for item in self.item_list:
			if item.get_name() == name:
				return item
		return False
		
		
	# return all items from category
	def item_list(self):
		return self.item_list
	
	
	
	def get_name(self):
		return self.name
	
	
	def set_name(self, name):
		self.name = name
		
		
	def get_icon(self):
		return self.icon
	
	
	def set_icon(self):
		self.icon = icon
		
		
	def item_count(self):
		i = 0
		for item in self.item_list:
			i = i + 1
		return i
	
	def to_string(self):
		print "-> %s: %s" % (self.name, self.item_count())
		for item in self.item_list:
			item.to_string()
		
	
	